package data

import (
	"actatempus_backend/internal/domain/entities"
	"context"

	E "github.com/IBM/fp-go/either"
)

// TimeEntryDataSource defines the operations for interacting with time entry data.
type TimeEntryDataSource interface {
	Create(ctx context.Context, entry entities.TimeEntryCreate) E.Either[error,entities.TimeEntry]
	FindByID(ctx context.Context, id string) E.Either[error,entities.TimeEntry]
	FindByUserID(ctx context.Context, userID string) E.Either[error,[]entities.TimeEntry]
	FindByProjectID(ctx context.Context, projectID string) E.Either[error,[]entities.TimeEntry]
	Update(ctx context.Context, entry entities.TimeEntryUpdate) E.Either[error,entities.TimeEntry]
	Delete(ctx context.Context, id string) E.Either[error,entities.TimeEntry]
	FindAll(ctx context.Context) E.Either[error,[]entities.TimeEntry]
}
